#!/usr/bin/env ruby

#
# $Id$
#
# Pref game model vairnats: Leningrad, Sochi, Rostov
#

require 'model/pref_calc_model'

#
# Leningrad's variant
#
class Leningrad < GameVariant
  def initialize
    @base_TP_on_game_for_whister = 4
    @base_TP_on_pass_out = 2
    @base_game_price = 2
    @base_UTP_on_game_for_player = 4
    @base_UTP_on_game_for_whister = 2
    @is_whist_gentlemanish = true
    @pass_out_counter_initial = 6
    @pass_out_counter_incremental = true
    @pass_out_counter_maximum = 8
    @pass_out_counter_wrap = true
  end
end


#
# Rostov's or Moscow's variant
#
class Rostov < GameVariant
  def initialize
    @base_TP_on_game_for_whister = 2
    # TODO: implement pass out to whists
    @base_TP_on_pass_out = 0
    @base_game_price = 2
    @base_UTP_on_game_for_player = 2
    @base_UTP_on_game_for_whister = 1

    @is_whist_gentlemanish = true
    @pass_out_counter_initial = 5
    @pass_out_counter_incremental = false
  end
end


#
# Sochi's variant
#
class Sochi < GameVariant
  def initialize
    @base_TP_on_game_for_whister = 2
    @base_TP_on_pass_out = 1
    @base_game_price = 2
    @base_UTP_on_game_for_player = 2
    @base_UTP_on_game_for_whister = 2
    @is_whist_gentlemanish = false
    @pass_out_counter_initial = 6
    @pass_out_counter_incremental = true
    @pass_out_counter_maximum = 8
    @pass_out_counter_wrap = false
  end
end


